#include "rcc_conf.h"

void rcc_conf(void){
//struktury inicjalizujace
	RCC_ClocksTypeDef RCC_Struct;
	
	SYSCFG_DeInit();
	RCC_DeInit();
	
	RCC_HSEConfig(RCC_HSE_ON);
	RCC_WaitForHSEStartUp();

	RCC_PLLConfig(RCC_PLLSource_HSE, RCC_PLLMul_6); //PLL daje 48MHz
	RCC_PLLCmd(ENABLE);

	while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) != SET); //czekanie na uruchomienie PLL
	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK); //rdzen wprost z PLL

	//dolaczenie zegara do szyn systemowych
	RCC_HCLKConfig(RCC_SYSCLK_Div1); //szyna AHB z PLL
	RCC_PCLKConfig(RCC_HCLK_Div1); //szyna APB z PLL

	RCC_HSICmd(DISABLE);
	

	//uruchomienie zegara dla peryferiow
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE); //wyzwalanie DAC
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE); //DAC
	
//konfiguracja SysTick
SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);
RCC_GetClocksFreq(&RCC_Struct);
SysTick_Config(RCC_Struct.HCLK_Frequency / 1000);
	
	
}
